votAnimatedLoad = {};
source(VariableOpeningTime.modDir.. "animated/votAnimated.lua");

function votAnimatedLoad:onStartMission()
	
end;

function votAnimatedLoad:object() --Beim starten in alle Animierten Objecte mit rein setzen wo startTime und endTime in der XML hinterlegt wurden
    votOldAnimatedObject = AnimatedObject.load;
    AnimatedObject.load = function(self, rootNode, xmlFile, key, xmlFilename, i3dMappings)
        local isOkay, result = pcall(votOldAnimatedObject, self, rootNode, xmlFile, key, xmlFilename, i3dMappings)		
		if isOkay and self ~= nil and xmlFile ~= nil then			
			if self.openingHours ~= nil and self.votOpeningTime == nil then			
				votSetGet:setOpeningTimeValuesAtObject(self, xmlFile, "placeable.animatedObjects.animatedObject(?).openingHours", "#startTime", "#endTime", false, false, votAnimated.viewOwnShowInfo, "animatedObject");
				if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 then
					if VariableOpeningTime.objects.animatedObject == nil then VariableOpeningTime.objects.animatedObject = {};end;
					VariableOpeningTime.objects.animatedObject[#VariableOpeningTime.objects.animatedObject+1] = self;
					votAnimatedLoad:manipulateObject(self);				
				end;
			end;	
			return result;
        end;		
		return result;
    end;
end;

function votAnimatedLoad:mapObject(object, xmlFile) --Beim starten in alle Map Animierten Objecte mit rein setzen wo startTime und endTime in der XML hinterlegt wurden, vorher passenden key ermitteln (alte LS 15/17/19 function)
	if object ~= nil and xmlFile ~= nil then
		local index = getUserAttribute(object.nodeId, "index");
		local key = nil;
		function searchKey() --alte LS 15/17/19 function by MultiOverlayV2 Hud			
			local i = 0
			while true do
				local objectKey = string.format("animatedObjects.animatedObject(%d)", i);
				if not xmlFile:hasProperty(objectKey) then
					break;
				end;
				local configIndex = xmlFile:getString(objectKey.. "#index");
				if configIndex == index then
					key = objectKey;
					break;
				end;
				i = i + 1;
			end;		
		end;				
		if index ~= nil then
			searchKey(); --key ermitteln
			if key ~= nil then
				votSetGet:setOpeningTimeValuesAtObject(object, xmlFile, key.. ".openingHours", "#startTime", "#endTime", false, false, votAnimated.viewOwnShowInfo, "animatedMapObject");
				if object.votOpeningTime ~= nil and #object.votOpeningTime > 0 then					
					if VariableOpeningTime.objects.animatedMapObject == nil then VariableOpeningTime.objects.animatedMapObject = {};end;
					VariableOpeningTime.objects.animatedMapObject[#VariableOpeningTime.objects.animatedMapObject+1] = object;
					votAnimatedLoad:manipulateObject(object);
				end;
			end;
		end;
	end;
end;

function votAnimatedLoad:manipulateObject(object) --for AnimatedObject and AnimatedMapObject, default werte speichern und 1x change ausführen beim starten der Map / --nur auf Client und Host Server ausführen, wird von LS selbst gesteuert
	if object.controls ~= nil then
		if object.controls.posAction ~= nil then
			object.votIsControlsPosAction = object.controls.posAction;
		end;				
		if object.controls.negAction ~= nil then
			object.votIsControlsNegAction = object.controls.negAction; 
		end;
	end;
	if object.autoopen ~= nil then --AnimatedObject Extend Mod Support
		object.votIsAutoOpen = object.autoopen;
	end;
	if object.autoTrigger ~= nil then 
		object.votIsAutoTrigger = object.autoTrigger; --AnimatedMapObject Support by Ackendorf 22 Map
	end;
	if object.openingHours == nil then 
		object.openingHours = {
			startTime = 26;
			endTime = 27;
			disableIfClosed = false;
			closedText = g_i18n:getText("vot_Closed", "closed"); --default
			opendedText = g_i18n:getText("vot_Opened", "opened"); --default			
		};		
	else
		object.openingHours.closedText = g_i18n:getText("vot_Closed", "closed"); --default
		object.openingHours.opendedText = g_i18n:getText("vot_Opened", "opened"); --default
	end;
	local votIsOpening, activeTime, _, _ = votSetGet:votIsOpening(object);				
	if votIsOpening then 
		object.openingHours.closedText = g_i18n:getText("vot_Opened", object.openingHours.opendedText);
		--object.openingHours.startTime = object.votOpeningTime[activeTime].startTime;
		--object.openingHours.endTime = object.votOpeningTime[activeTime].endTime;					
	else
		object.openingHours.closedText = g_i18n:getText("vot_Closed", object.openingHours.closedText);	
		--object.openingHours.startTime = 26;
		--object.openingHours.endTime = 27;
	end;
	if object.votShowInfo then object.openingHours.closedText = nil;end;
	g_messageCenter:subscribe(MessageType.HOUR_CHANGED, object.hourChanged, object); --change	
end;