votFence = {};
votFence.viewOwnShowInfo = true;

function votFence.updateSegmentShapes(self, segment)	
	if self ~= nil and segment ~= nil and segment.gateIndex ~= nil then
		local animatedObject = segment.animatedObject;		
		if animatedObject ~= nil then			
			local spec = self.spec_fence;
			if spec ~= nil and segment.gateIndex ~= nil then				
				local object = spec.gates[segment.gateIndex];
				if object ~= nil and object.votOpeningTime ~= nil and #object.votOpeningTime > 0 and object.votTyp ~= nil then 
					animatedObject.votOpeningTime = object.votOpeningTime;
					animatedObject.votTyp = object.votTyp;
					animatedObject.votOtherMod = object.votOtherMod;
					animatedObject.votIsOpening = object.votIsOpening;
					animatedObject.votActiveOpeningTime = object.votActiveOpeningTime;
					animatedObject.votNextActiveOpeningTime = object.votNextActiveOpeningTime;
					animatedObject.votShowInfo = object.votShowInfo;
					animatedObject.votFrameText = object.votFrameText;
					animatedObject.votNextHour = object.votNextHour;
					animatedObject.votRevamp = object.votRevamp;					
					votAnimatedLoad:manipulateObject(animatedObject);
				end;
			end;
		end;
	end;
end;
PlaceableFence.updateSegmentShapes = Utils.appendedFunction(PlaceableFence.updateSegmentShapes, votFence.updateSegmentShapes);