votBeehive = {};
votBeehive.viewOwnShowInfo = true;

function votBeehive.updateState(self, superFunc) --Honig Produktion erlauben oder verbieten	
	if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 then	
		votSetGet:votIsOpening(self);		
		if not self.votIsOpening then 
			local spec = self.spec_beehive;			
			--if g_currentMission.beehiveSystem.isProductionActive then --disabled falls season/sun bedingt sowieso keine produktion statt findet, wir brauchen aber den status von isProductionActive/isFxActive für die frameBox
				spec.isProductionActive = false;
				spec.isFxActive = false;
				if self.isClient then --Bienen und Sound deaktivieren / --nur auf Client und Host Server ausführen
					g_effectManager:stopEffects(spec.effects);
					g_soundManager:stopSample(spec.samples.idle);
				end;
				return;
			--end;
		end;
	end;
	return superFunc(self);
end;

function votBeehive:updateInfo(self, superFunc, infoTable)
	if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 then
		if self.votShowInfo then			
			votUpdate:showInfo(self, infoTable, false);			
		end;
	end;
end;



function votBeehive:ownShowInfo(box, infoTable)			
	if not votBeehive.viewOwnShowInfo then return false;end;
	local objectName = nil;
	if box.object.getName ~= nil then objectName = box.object:getName();end;		
	local infoTable = votUpdate:showInfo(box.object, infoTable or {}, true, objectName or "");
	if infoTable ~= nil and #infoTable > 0 then		
		for i=1, #infoTable do
			box:addLine(infoTable[i].title, infoTable[i].text, infoTable[i].accentuate or false, infoTable[i].accentuateColor);
		end;
		--box:addLine("nodeId", tostring(box.object.rootNode or box.object.nodeId));
		return true;
	end;	
	return false;
end;
PlaceableBeehive.updateBeehiveState = Utils.overwrittenFunction(PlaceableBeehive.updateBeehiveState, votBeehive.updateState);
if not votBeehive.viewOwnShowInfo then PlaceableBeehive.updateInfo = Utils.appendedFunction(PlaceableBeehive.updateInfo, votBeehive.updateInfo);end;