votProductionInGameFrame = {};

function votProductionInGameFrame.updateDetails(self) --LS22 InGameMenuProductionFrame überwachen / --nur auf Client und Hoste Server ausführen
	if VariableOpeningTime:getServer() then return;end; 
	local production, productionPoint = self:getSelectedProduction()
	if production == nil then
		return;
	end;	
	votProductionInGameFrame:replaceStatus(self, productionPoint, production.status);	
	--self.noPointsBox.visible; Wenn keine Produktionsgebäude vorhanden sind, later für other Mod nutzen
	if self.detailsBox ~= nil and self.detailsBox.visible and self.detailsBox.elements ~= nil then				
		votProductionInGameFrame:visibleTitleAndTime(self, productionPoint);		
		votProductionInGameFrame:visibleCurrentTime(self, productionPoint);
		for e=1, #self.detailsBox.elements do
			local element = self.detailsBox.elements[e];
			if element ~= nil then				
				if element.profile == "ingameMenuProductionColumnTitle" then
					votProductionInGameFrame:generateTitle(self, productionPoint, element.position[2]);
					votProductionInGameFrame:generateOpeningTime(self, productionPoint, element.position[2]);
					votProductionInGameFrame:generateInfo(self, productionPoint, element.position[2]);
					votProductionInGameFrame:generateCurrentTime(self, productionPoint, element.position[2], element.position[1]);
					self.storageList:reloadData();
					break;
				end;				
			end;
		end;
	end;	
end;

function votProductionInGameFrame:replaceStatus(frame, productionPoint, status) --Produktions Status überwachen und gegebenfalls überschreiben
	if frame == nil or productionPoint == nil then return;end;	
	if productionPoint.votIsOpening == nil then return;end;
	if VariableOpeningTime:getClient() then votSetGet:votIsOpening(productionPoint);end; --manuel auf Clients anstupsen weil der Status nicht vom Server übertragen wird
	if status ~= 0 and not productionPoint.votIsOpening then frame.detailProductionStatus:setValue(g_i18n:getText("vot_Closed", "closed"));frame.detailProductionStatus:setTextColor(unpack(g_currentMission.hl.getColor("red", true, {1,1,1,1})));return;end;
	if (tostring(frame.detailProductionStatus:getValue("detailProductionStatus")) == g_i18n:getText("vot_Closed", "closed")) or productionPoint.votIsOpening or status == 0 then frame.detailProductionStatus:setTextColor(unpack({1,1,1,1}));frame.detailProductionStatus:setValue(g_i18n:getText(ProductionPoint.PROD_STATUS_TO_L10N[status]) or "unknown");end;
end;
InGameMenuProductionFrame.updateDetails = Utils.appendedFunction(InGameMenuProductionFrame.updateDetails, votProductionInGameFrame.updateDetails);

function votProductionInGameFrame.update(self, dt)
	if VariableOpeningTime.ingameProductionFrame.currentTime then
		if self.detailsBox ~= nil and self.detailsBox.visible and self.detailsBox.elements ~= nil then
			for e=1, #self.detailsBox.elements do
				local element = self.detailsBox.elements[e];
				if element ~= nil then
					if element.votLine ~= nil and element.votLine == "currentTime" then													
						element.text = votSetGet:getCurrentTime();					
					end;
				end;
			end;
		end;
	end;
end;
InGameMenuProductionFrame.update = Utils.appendedFunction(InGameMenuProductionFrame.update, votProductionInGameFrame.update)

function votProductionInGameFrame:setTitleAndTimeText(productionPoint) --Für Frames feste Titel/Zeilen Texte erstellen/hinterlegen
	if productionPoint.votOpeningTime ~= nil and #productionPoint.votOpeningTime > 0 then
		productionPoint.votFrameText.isLoad = true;
		productionPoint.votFrameText.title = Utils.getNoNil(g_i18n:getText("vot_WorkingHours"), "Workinghours").. ":";
		local separator = " / ";
		if #productionPoint.votOpeningTime == 1 then separator = "";end;		
		for a=1, #productionPoint.votOpeningTime do
			local openingTime = productionPoint.votOpeningTime[a];			
			if a == #productionPoint.votOpeningTime then
				productionPoint.votFrameText.openingTime = productionPoint.votFrameText.openingTime.. string.format(g_i18n:getText("vot_ClockTime"), tostring(openingTime.startTime), tostring(openingTime.endTime));
			else
				productionPoint.votFrameText.openingTime = productionPoint.votFrameText.openingTime.. tostring(openingTime.startTime).. "-".. tostring(openingTime.endTime).. separator;
			end;			
		end;		
	end;
end;

function votProductionInGameFrame:setInfoText(productionPoint, infoTxt) --Für Frames, variablen Info Text erstellen/hinterlegen
	if productionPoint.votOpeningTime ~= nil and #productionPoint.votOpeningTime > 0 then
		productionPoint.votFrameText.info = tostring(infoTxt);
	end;
end;

function votProductionInGameFrame:visibleTitleAndTime(frame, productionPoint) --Frame Titel/Zeiten Text aktualisieren und freigeben oder sperren / speciale für andere Mods beachten/prüfen und gegebenfalls ersetzen 
	if productionPoint == nil then return;end;
	local int = 0;
	for e=1, #frame.detailsBox.elements do
		local element = frame.detailsBox.elements[e];
		if element ~= nil then			
			if not VariableOpeningTime.ingameProductionFrame.title and not VariableOpeningTime.ingameProductionFrame.openingTime then break;end;			
			if VariableOpeningTime.ingameProductionFrame.title and element.votLine ~= nil and element.votLine == "title" then
				if productionPoint.votOpeningTime == nil or #productionPoint.votOpeningTime <= 0 or not frame.detailsBox.visible then
					if (not productionPoint.votOtherMod.active and not frame.detailsBox.visible) or not frame.detailsBox.visible then
						element.text = "";					
						element.visible = false;
					else
						element.text = productionPoint.votOtherMod.title;
					end;
					int = int+1;					
				else
					if not productionPoint.votOtherMod.active then
						element.text = productionPoint.votFrameText.title;
					else
						element.text = productionPoint.votOtherMod.title;
					end;					
					element.visible = true;
					int = int+1;
				end;
				VariableOpeningTime.ingameProductionFrame.titleWidth = getTextWidth(element.textSize, utf8Substr(element.text.. "-----", 0));				
			end;
			if VariableOpeningTime.ingameProductionFrame.openingTime and element.votLine ~= nil and element.votLine == "openingTime" then				
				if productionPoint.votOpeningTime == nil or #productionPoint.votOpeningTime <= 0 or not frame.detailsBox.visible then
					if (not productionPoint.votOtherMod.active and not frame.detailsBox.visible) or not frame.detailsBox.visible then
						element.text = "";					
						element.visible = false;
					else
						element.text = productionPoint.votOtherMod.text;
						element.textColor = g_currentMission.hl.getColor("orangeRed", true);
					end;
					int = int+1;					
				else
					if element.position[1] ~= VariableOpeningTime.ingameProductionFrame.titlePosX+VariableOpeningTime.ingameProductionFrame.titleWidth then element.position[1] = VariableOpeningTime.ingameProductionFrame.titlePosX+VariableOpeningTime.ingameProductionFrame.titleWidth;element:updateAbsolutePosition();end;
					if not productionPoint.votOtherMod.active then
						element.text = productionPoint.votFrameText.openingTime.. productionPoint.votOtherMod.info;
						if not productionPoint.votIsOpening then
							element.textColor = g_currentMission.hl.getColor("yellow", true);
						else
							element.textColor = g_currentMission.hl.getColor("green", true);
						end;
					else
						element.text = productionPoint.votOtherMod.text;
						element.textColor = g_currentMission.hl.getColor("orangeRed", true);
					end;					
					element.visible = true;
					int = int+1;
				end;
				VariableOpeningTime.ingameProductionFrame.openingTimeWidth = getTextWidth(element.textSize, utf8Substr(element.text.. "---", 0));
				VariableOpeningTime.ingameProductionFrame.openingTimePosX = VariableOpeningTime.ingameProductionFrame.titlePosX+VariableOpeningTime.ingameProductionFrame.titleWidth;
			end;
			if VariableOpeningTime.ingameProductionFrame.info and element.votLine ~= nil and element.votLine == "info" then
				if productionPoint.votOpeningTime == nil or #productionPoint.votOpeningTime <= 0 or not frame.detailsBox.visible then
					--if (productionPoint.votOtherMod.active and not frame.detailsBox.visible) or not frame.detailsBox.visible then
						element.text = "";					
						element.visible = false;					
					--end;
					int = int+1;
				else
					if element.position[1] ~= VariableOpeningTime.ingameProductionFrame.openingTimePosX+VariableOpeningTime.ingameProductionFrame.openingTimeWidth then element.position[1] = VariableOpeningTime.ingameProductionFrame.openingTimePosX+VariableOpeningTime.ingameProductionFrame.openingTimeWidth;element:updateAbsolutePosition();end;
					if element.position[2] ~= VariableOpeningTime.ingameProductionFrame.openingTimePosY then element.position[2] = VariableOpeningTime.ingameProductionFrame.openingTimePosY;element:updateAbsolutePosition();end;
					if not productionPoint.votOtherMod.active and productionPoint.votOtherMod.info:len() == 0 then
						if not productionPoint.votIsOpening and productionPoint.votFrameText.info:len() == 0 then 
							element.text = tostring(g_i18n:getText("vot_Closed", "closed"));
							element.textColor = g_currentMission.hl.getColor("orangeRed", true);
						elseif productionPoint.votIsOpening and productionPoint.votFrameText.info:len() == 0 then
							element.text = tostring(g_i18n:getText("vot_Opened", "opened"));
							element.textColor = g_currentMission.hl.getColor("activeGreen", true);
						else
							element.text = productionPoint.votFrameText.info;
							element.textColor = g_currentMission.hl.getColor("orangeRed", true);
						end;
					end;
					element.visible = true;
					int = int+1;
				end;
			end;
			if int >= 3 then break;end;
		end;
	end;	
end;

function votProductionInGameFrame:visibleCurrentTime(frame, productionPoint) --Frame CurrentTime Text aktualisieren und weiterleiten
	return true;
end;

function votProductionInGameFrame:generateCurrentTime(frame, object, posY, posX) --1x CurrentTime Frame generien *Clock/Uhr*
	if frame == nil then return;end;
	if not VariableOpeningTime.ingameProductionFrame.currentTime then
		VariableOpeningTime.ingameProductionFrame.currentTime = true;
		local currentTimeTxt = TextElement.new();
		currentTimeTxt:copyAttributes(frame.productionCostsDesc);
		currentTimeTxt.text = votSetGet:getCurrentTime();		
		currentTimeTxt.textColor = g_currentMission.hl.getColor("ls22", true, currentTimeTxt.textColor);		
		currentTimeTxt.textBold = true;
		currentTimeTxt.votLine = "currentTime";
		currentTimeTxt.position[1] = posX-getTextWidth(currentTimeTxt.textSize, utf8Substr(currentTimeTxt.text.. "-----", 0));
		currentTimeTxt.position[2] = posY-(posY*2)+getTextHeight(currentTimeTxt.textSize, utf8Substr(currentTimeTxt.text, 0));				
		currentTimeTxt.visible = true;		
		frame.detailsBox:addElement(currentTimeTxt);						
		currentTimeTxt:updateAbsolutePosition();		
	end;
end;

function votProductionInGameFrame:generateTitle(frame, object, posY) --1x Title Frame generien *Workinghours/Arbeitszeiten*
	if frame == nil then return;end;
	if not VariableOpeningTime.ingameProductionFrame.title then
		VariableOpeningTime.ingameProductionFrame.title = true;
		local titleTxt = TextElement.new();
		titleTxt:copyAttributes(frame.productionCostsDesc);
		titleTxt.text = Utils.getNoNil(g_i18n:getText("vot_WorkingHours"), "Workinghours").. ":";		
		titleTxt.textColor = g_currentMission.hl.getColor("activeGreen", true, titleTxt.textColor);		
		titleTxt.textBold = true;
		titleTxt.votLine = "title";
		VariableOpeningTime.ingameProductionFrame.titleHeight = getTextHeight(titleTxt.textSize, utf8Substr(titleTxt.text, 0));
		VariableOpeningTime.ingameProductionFrame.titleWidth = getTextWidth(titleTxt.textSize, utf8Substr(titleTxt.text.. "----------", 0));
		titleTxt.position[2] = posY-(posY*2)+VariableOpeningTime.ingameProductionFrame.titleHeight;
		VariableOpeningTime.ingameProductionFrame.titlePosX = titleTxt.position[1];
		VariableOpeningTime.ingameProductionFrame.titlePosY = titleTxt.position[2];		
		titleTxt.visible = false;
		frame.detailsBox:addElement(titleTxt);						
		titleTxt:updateAbsolutePosition();		
	end;
end;

function votProductionInGameFrame:generateOpeningTime(frame, object, posY) --1x Zeiten Frame generien *--..-.. / ..-.. Clock/Uhr*
	if frame == nil then return;end;
	if VariableOpeningTime.ingameProductionFrame.title and not VariableOpeningTime.ingameProductionFrame.openingTime then
		VariableOpeningTime.ingameProductionFrame.openingTime = true;
		local timeTxt = TextElement.new();
		timeTxt:copyAttributes(frame.productionCostsDesc);
		timeTxt.text = ""; --"..-.. / ..-.. / ..-.. / "..	string.format(g_i18n:getText("vot_ClockTime"), tostring(00), tostring(00));				
		timeTxt.textColor = g_currentMission.hl.getColor("yellow", true, timeTxt.textColor);		
		--timeTxt.textBold = true;
		timeTxt.votLine = "openingTime";
		VariableOpeningTime.ingameProductionFrame.openingTimeHeight = VariableOpeningTime.ingameProductionFrame.titleHeight;
		VariableOpeningTime.ingameProductionFrame.openingTimeWidth = getTextWidth(timeTxt.textSize, utf8Substr(timeTxt.text.. "---", 0));
		timeTxt.position[1] = VariableOpeningTime.ingameProductionFrame.titlePosX+VariableOpeningTime.ingameProductionFrame.titleWidth;
		timeTxt.position[2] = VariableOpeningTime.ingameProductionFrame.titlePosY;
		VariableOpeningTime.ingameProductionFrame.openingTimePosX = timeTxt.position[1];
		VariableOpeningTime.ingameProductionFrame.openingTimePosY = timeTxt.position[2];
		timeTxt.visible = false;
		frame.detailsBox:addElement(timeTxt);						
		timeTxt:updateAbsolutePosition();		
	end;
end;

function votProductionInGameFrame:generateInfo(frame, object, posY) --1x Zeiten Frame generien *--..-.. / ..-.. Clock/Uhr*
	if frame == nil then return;end;
	if VariableOpeningTime.ingameProductionFrame.title and VariableOpeningTime.ingameProductionFrame.openingTime and not VariableOpeningTime.ingameProductionFrame.info then
		VariableOpeningTime.ingameProductionFrame.info = true;
		local infoTxt = TextElement.new();
		infoTxt:copyAttributes(frame.productionCostsDesc);
		infoTxt.text = "";					
		infoTxt.textColor = g_currentMission.hl.getColor("orangeRed", true, infoTxt.textColor);		
		infoTxt.textBold = true;
		infoTxt.votLine = "info";
		infoTxt.position[1] = VariableOpeningTime.ingameProductionFrame.openingTimePosX+VariableOpeningTime.ingameProductionFrame.openingTimeWidth;
		infoTxt.position[2] = VariableOpeningTime.ingameProductionFrame.openingTimePosY;
		infoTxt.visible = false;
		frame.detailsBox:addElement(infoTxt);						
		infoTxt:updateAbsolutePosition();		
	end;
end;