votRegister = {};

function votRegister.productionPointXMLPaths(schema, basePath) --XML Werte registrieren
	--for a=1, VariableOpeningTime.maxStartEndTime do
		schema:register(XMLValueType.STRING, basePath .. ".productions.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
		schema:register(XMLValueType.STRING, basePath .. ".productions.openingHours#endTime", "Multiple End Time", nil);
		schema:register(XMLValueType.BOOL, basePath .. ".production.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
		schema:register(XMLValueType.INT, basePath .. ".production.openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
		schema:register(XMLValueType.BOOL, basePath .. ".production.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
		schema:register(XMLValueType.BOOL, basePath .. ".production.openingHours#unloadingIfClosed", "Vehicle can Unloading / if production closed", false); --default false
		schema:register(XMLValueType.BOOL, basePath .. ".production.openingHours#loadingIfClosed", "Vehicle can Loading / if production closed", false); --default false
	--end;		
end;

function votRegister.extendedProductionPointXMLPaths(schema, basePath) --XML Werte registrieren / Map Hof Bergmann Support grrrrr.....
	schema:setXMLSpecializationType("ExtendedProductionPoint");
	schema:register(XMLValueType.STRING, basePath .. ".extendedProductionPoint.productions.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".extendedProductionPoint.productions.openingHours#endTime", "Multiple End Time", nil);
	schema:register(XMLValueType.BOOL, basePath .. ".extendedProductionPoint.production.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".extendedProductionPoint.productions.openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".extendedProductionPoint.production.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
	schema:register(XMLValueType.BOOL, basePath .. ".extendedProductionPoint.production.openingHours#unloadingIfClosed", "Vehicle can Unloading / if production closed", false); --default false
	schema:register(XMLValueType.BOOL, basePath .. ".extendedProductionPoint.production.openingHours#loadingIfClosed", "Vehicle can Loading / if production closed", false); --default false
end;

function votRegister.animatedObjectXMLPaths(schema, basePath) --XML Werte registrieren
	schema:setXMLSharedRegistration("AnimatedObject", basePath);
	basePath = basePath .. ".animatedObject(?)";	
	schema:register(XMLValueType.BOOL, basePath .. ".openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

function votRegister.beehiveXMLPaths(schema, basePath) --XML Werte registrieren
	schema:setXMLSpecializationType("Beehive");	
	schema:register(XMLValueType.STRING, basePath .. ".beehive.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".beehive.openingHours#endTime", "Multiple End Time", nil);
	schema:register(XMLValueType.BOOL, basePath .. ".beehive.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".beehive.openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".beehive.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

function votRegister.windTurbineXMLPaths(schema, basePath) --XML Werte registrieren
	schema:setXMLSpecializationType("WindTurbine");	
	schema:register(XMLValueType.STRING, basePath .. ".windTurbine.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".windTurbine.openingHours#endTime", "Multiple End Time", nil);
	schema:register(XMLValueType.BOOL, basePath .. ".windTurbine.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".windTurbine.openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".windTurbine.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

function votRegister.windTurbineXMLPaths(schema, basePath) --XML Werte registrieren
	schema:setXMLSpecializationType("SolarPanels");	
	schema:register(XMLValueType.STRING, basePath .. ".solorPanels.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".solarPanels.openingHours#endTime", "Multiple End Time", nil);
	schema:register(XMLValueType.BOOL, basePath .. ".solarPanels.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".solarPanels.openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".solorPanels.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

function votRegister.fenceXMLPaths(schema, basePath) --XML Werte registrieren
	schema:setXMLSpecializationType("Fence");	
	basePath = basePath .. ".fence.gate(?)";
	schema:register(XMLValueType.STRING, basePath .. ".openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".openingHours#endTime", "Multiple End Time", nil);
	schema:register(XMLValueType.BOOL, basePath .. ".openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

function votRegister.sellingStationXMLPaths(schema, basePath) --XML Werte registrieren
	schema:setXMLSpecializationType("SellingStation");	
	schema:register(XMLValueType.STRING, basePath .. ".sellingStation.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".sellingStation.openingHours#endTime", "Multiple End Time", nil);
	schema:register(XMLValueType.BOOL, basePath .. ".sellingStation.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".sellingStation.openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".sellingStation.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

function votRegister.siloXMLPaths(schema, basePath) --XML Werte registrieren
	schema:setXMLSpecializationType("Silo");	
	schema:register(XMLValueType.STRING, basePath .. ".silo.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".silo.openingHours#endTime", "Multiple End Time", nil);
	schema:register(XMLValueType.BOOL, basePath .. ".silo.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".silo.openingHours#infoWhen", "InfoWhen Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".silo.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

function votRegister.buyingStationXMLPaths(schema, basePath) --XML Werte registrieren
	schema:setXMLSpecializationType("BuyingStation");
	schema:register(XMLValueType.STRING, basePath .. ".buyingStation.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".buyingStation.openingHours#endTime", "Multiple End Time", nil);	
	schema:register(XMLValueType.BOOL, basePath .. ".buyingStation.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".buyingStation.openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".buyingStation.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

function votRegister.chargingStationXMLPaths(schema, basePath)
	schema:setXMLSpecializationType("BuyingStation");
	schema:register(XMLValueType.STRING, basePath .. ".chargingStation.openingHours#startTime", "Multiple Starting Time", nil); --als String weil wir diesen besser verarbeiten können
	schema:register(XMLValueType.STRING, basePath .. ".chargingStation.openingHours#endTime", "Multiple End Time", nil);	
	schema:register(XMLValueType.BOOL, basePath .. ".chargingStation.openingHours#showInfo", "ShowInfo all OpeningTimes", true); --default true
	schema:register(XMLValueType.INT, basePath .. ".chargingStation.openingHours#infoWhen", "InfoWhen Next Closed/Opended at Minutes 0-60 in InfoTrigger or ...", 15); --default 15 minutes
	schema:register(XMLValueType.BOOL, basePath .. ".chargingStation.openingHours#globalInfo", "Global Info Next Closed/Opended", false); --default false
end;

if PlaceableExtendedProductionPoint ~= nil then PlaceableExtendedProductionPoint.registerXMLPaths = Utils.prependedFunction(PlaceableExtendedProductionPoint.registerXMLPaths, votRegister.extendedProductionPointXMLPaths);end;

--PlaceableBuyingStation.registerXMLPaths = Utils.prependedFunction(PlaceableBuyingStation.registerXMLPaths, votRegister.buyingStationXMLPaths);
--PlaceableSilo.registerXMLPaths = Utils.prependedFunction(PlaceableSilo.registerXMLPaths, votRegister.siloXMLPaths);
--PlaceableSellingStation.registerXMLPaths = Utils.prependedFunction(PlaceableSellingStation.registerXMLPaths, votRegister.sellingStationXMLPaths);
--PlaceableSolarPanels.registerXMLPaths = Utils.prependedFunction(PlaceableSolarPanels.registerXMLPaths, votRegister.solarPanelsXMLPaths);
--PlaceableWindTurbine.registerXMLPaths = Utils.prependedFunction(PlaceableWindTurbine.registerXMLPaths, votRegister.windTurbineXMLPaths);
--PlaceableChargingStation.registerXMLPaths = Utils.prependedFunction(PlaceableChargingStation.registerXMLPaths, votRegister.chargingStationXMLPaths);
PlaceableFence.registerXMLPaths = Utils.prependedFunction(PlaceableFence.registerXMLPaths, votRegister.fenceXMLPaths);
AnimatedObject.registerXMLPaths = Utils.prependedFunction(AnimatedObject.registerXMLPaths, votRegister.animatedObjectXMLPaths);
ProductionPoint.registerXMLPaths = Utils.prependedFunction(ProductionPoint.registerXMLPaths, votRegister.productionPointXMLPaths);
PlaceableBeehive.registerXMLPaths = Utils.prependedFunction(PlaceableBeehive.registerXMLPaths, votRegister.beehiveXMLPaths); 