votAnimated = {};
votAnimated.viewOwnShowInfo = true;

function votAnimated.objectTriggerCallback(self, triggerId, otherId, onEnter, onLeave, onStay) --nur auf Client und Host Server ausführen	
	if g_currentMission ~= nil and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then		
		if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 and self.votTyp ~= nil then 
			--votAnimated.objectHourChanged(self); --change
			local typNode = self.rootNode or self.nodeId;			
			if typeNode == nil or typeNode == 0 then typNode = triggerId;end;
			if typNode ~= nil and typNode ~= 0 then
				local typ = self.votTyp.. "_".. tostring(typNode);				
				if VariableOpeningTime.ingameBoxFrames.hudBox[typ] ~= nil then
					if onEnter or onStay then
						--VariableOpeningTime.ingameBoxFrames.hudBox[typ].object = self;
						VariableOpeningTime.ingameBoxFrames.hudBox[typ].visible = true;				
					elseif onLeave then
						VariableOpeningTime.ingameBoxFrames.hudBox[typ].visible = false;							
					end;
				else
					votSetGet:generateIngameOpeningTimeFrameBoxChange(self, typ); --change
				end;
			end;
		end;
	end;	
end;

function votAnimated.objectHourChanged(self) --Animation erlauben oder verbieten / manuelles öffnen per Key/Mouse beachten / --nur auf Client und Host Server ausführen	
	if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 and self.openingHours ~= nil then		
		votSetGet:votIsOpening(self);		
		local moreTxt = "";
		if not self.votIsOpening then
			if self.votIsAutoOpen ~= nil then self.autoopen = false;end; --AnimatedObject Extend Mod Support			
			if self.votIsAutoTrigger ~= nil then self.autoTrigger = false;end; --AnimatedMapObject Support by Ackendorf 22 Map
			if self.votIsControlsPosAction ~= nil then self.controls.posAction = nil;end;
			if self.votIsControlsNegAction ~= nil then self.controls.negAction = nil;end;
			--if self.votNextOpenedHour ~= nil and self.votNextOpenedHour >= 0 then moreTxt = "-".. g_i18n:getText("vot_OpenedNext", "OpenedNext").. "  (".. string.format(string.gsub(g_i18n:getText("vot_ClockTime"), "-", ""), "", tostring(self.votNextOpenedHour)).. ")";end; --könnte man auch in Minuten anzeigen, statt in Stunde
			if self.openingHours.closedText ~= nil then self.openingHours.closedText = g_i18n:getText("vot_Closed", "closed").. tostring(moreTxt);end;						
			if VariableOpeningTime:canProcess("client") then 
				g_inputBinding:setActionEventTextVisibility(self.controls.posActionEventId, false);
				g_inputBinding:setActionEventTextVisibility(self.controls.negActionEventId, false);	
				--if self.controls.posActionEventId ~= nil then self.controls.posActionEventId = nil;end;
				--if self.controls.negActionEventId ~= nil then self.controls.negActionEventId = nil;end;
			end;			
			if #self.votOpeningTime > 1 then
				self.openingHours.startTime = 26; --ghost time
				self.openingHours.endTime = 27; --ghost time
			end;
		else
			--if self.openingHours.isOpen then self.openingHours.isOpen = false;end;
			if self.votIsAutoOpen ~= nil then self.autoopen = self.votIsAutoOpen;end; --AnimatedObject Extend Mod Support
			if self.votIsAutoTrigger ~= nil then self.autoTrigger = self.votIsAutoTrigger;end; --AnimatedMapObject Support by Ackendorf 22 Map
			if self.votIsControlsPosAction ~= nil then self.controls.posAction = self.votIsControlsPosAction;end; 
			if self.votIsControlsNegAction ~= nil then self.controls.negAction = self.votIsControlsNegAction;end;
			--if self.votNextClosedHour ~= nil and self.votNextClosedHour >= 0 then moreTxt = g_i18n:getText("vot_ClosedNext").. "  (".. string.format(string.gsub(g_i18n:getText("vot_ClockTime"), "-", ""), "", tostring(self.votNextClosedHour)).. ")";end; --könnte man auch in Minuten anzeigen, statt in Stunde
			if self.openingHours.closedText ~= nil then self.openingHours.closedText = g_i18n:getText("vot_Opened", "opened").. tostring(moreTxt);end;
			self.openingHours.startTime = self.votOpeningTime[self.votActiveOpeningTime].startTime;
			self.openingHours.endTime = self.votOpeningTime[self.votActiveOpeningTime].endTime;
		end;				
	end;	
end;

function votAnimated:ownShowInfo(box, infoTable)	
	if not votAnimated.viewOwnShowInfo then	return false;end;	
	local objectName = nil;
	if box.object.saveId ~= nil then objectName = box.object.saveId;end;	
	if string.find(objectName, "AnimatedObject_") then objectName = "Unknown Door";end;
	local infoTable = votUpdate:showInfo(box.object, infoTable or {}, true, objectName or "");
	if infoTable ~= nil and #infoTable > 0 then		
		for i=1, #infoTable do
			box:addLine(infoTable[i].title, infoTable[i].text, infoTable[i].accentuate or false, infoTable[i].accentuateColor);
		end;		
		if box.object.votIsAutoOpen ~= nil or box.object.votIsAutoTrigger ~= nil then --Mod Support
			local title = "Mod Auto Open/Close";
			local autoState = g_i18n:getText("ui_yes", "Yes");
			local color = g_currentMission.hl.getColor("green", true);
			if box.object.votIsAutoOpen ~= nil and box.object.votIsAutoTrigger ~= nil then 
				title = title.. "/2x"
				if box.object.votIsAutoTrigger ~= box.object.votIsAutoOpen then
					autoState = g_i18n:getText("ui_yes", "Yes").. "/".. g_i18n:getText("ui_no", "No");
					title = "! ".. title
					color = g_currentMission.hl.getColor("yellow", true);
				end;
			else
				if box.object.votIsAutoTrigger ~= nil and not box.object.votIsAutoTrigger then autoState = g_i18n:getText("ui_no", "No");end;
				if box.object.votIsAutoOpen ~= nil and not box.object.votIsAutoOpen then autoState = g_i18n:getText("ui_no", "No");end;
			end;
			box:addLine(tostring(title), tostring(autoState), true, color);	
		end;
		--box:addLine("nodeId", tostring(box.object.rootNode or box.object.nodeId));
		return true;
	end;
	return false;	
end;

function votAnimated.objectAnimationInpurContinuous(self)
	if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 and self.openingHours ~= nil then	
		votSetGet:votIsOpening(self);
		return;
	end;
end;
AnimatedObject.triggerCallback = Utils.prependedFunction(AnimatedObject.triggerCallback, votAnimated.objectTriggerCallback);
AnimatedObject.hourChanged = Utils.appendedFunction(AnimatedObject.hourChanged, votAnimated.objectHourChanged);