votProduction = {};
votProduction.viewOwnShowInfo = true;

function votProduction.update(self) --Produktionen erlauben oder verbieten
	if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 then		
		votSetGet:votIsOpening(self);			
		if VariableOpeningTime:canProcess("server") or VariableOpeningTime:getSp() then --nur auf Server / Hoste Server oder SP ausführen
			if not self.votIsOpening then self.lastUpdatedTime = nil;if self.palletSpawner ~= nil then self.palletSpawnCooldown = g_time + ProductionPoint.NO_PALLET_SPACE_COOLDOWN;end;end;
		end;		
	end;
end;

function votProduction:updateInfo(superFunc, infoTable)	
	if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 then		
		if self.votShowInfo then			
			votUpdate:showInfo(self, infoTable, false);			
		end;
	end;
end;

function votProduction:updateInfoStatus(superFunc, infoTable)	
	if self.votOpeningTime ~= nil and #self.votOpeningTime > 0 then		
		if self.votShowInfo and not self.votIsOpening then			
			votUpdate:replaceProductionPointStatus(self, infoTable)			
		end;
	end;
end;

function votProduction:ownShowInfo(box, infoTable)			
	if not votProduction.viewOwnShowInfo then return false;end;
	local objectName = nil;
	if box.object.getName ~= nil then objectName = box.object:getName();end;	
	local infoTable = votUpdate:showInfo(box.object, infoTable or {}, true, objectName or "");
	if infoTable ~= nil and #infoTable > 0 then
		for i=1, #infoTable do
			box:addLine(infoTable[i].title, infoTable[i].text, infoTable[i].accentuate or false, infoTable[i].accentuateColor);
		end;
		--box:addLine("nodeId", tostring(box.object.rootNode or box.object.nodeId));
		return true;
	end;
	return false;	
end;

function votProduction:updateFxState(self, productionPoint) --! Bei Produktionen den Sound deaktivieren !
	if VariableOpeningTime:getServer() then return;end; --nur auf Client und Host Server ausführen
	--if self ~= nil and productionPoint ~= nil and productionPoint.votOpeningTime ~= nil and #productionPoint.votOpeningTime > 0 and not productionPoint.votIsOpening then
	--	g_soundManager:playSample(self.samples.idle);
	--	g_soundManager:stopSample(self.samples.active);
	--	g_animationManager:stopAnimations(self.animationNodes);
	--	g_effectManager:stopEffects(self.effects);
	--end;
end;
ProductionPoint.updateProduction = Utils.appendedFunction(ProductionPoint.updateProduction, votProduction.update);
if not votProduction.viewOwnShowInfo then ProductionPoint.updateInfo = Utils.appendedFunction(ProductionPoint.updateInfo, votProduction.updateInfo);end;
if votProduction.viewOwnShowInfo then ProductionPoint.updateInfo = Utils.appendedFunction(ProductionPoint.updateInfo, votProduction.updateInfoStatus);end;
--ProductionPoint.updateFxState = Utils.appendedFunction(ProductionPoint.updateFxState, votProduction.updateFxState);

