votSetGet = {};

function votSetGet:votIsOpening(object) --Objecte prüfen ob sie geöffnet haben oder arbeiten etc./ auf allen prüfen Server,Host Server und Client und Werte optional setzen
	if object == nil or object.votOpeningTime == nil or #object.votOpeningTime <= 0 then return nil;end;
	local currentHour = g_currentMission.environment.currentHour;
	if currentHour == 0 then currentHour = 24;end;
	local currentMin = g_currentMission.environment.currentMinute;
	local votIsOpening = false;	
	local nextOpenedHour = 0;
	local tempNextOpenedHour = 24;
	local nextClosedHour = 0;
	local activeOpeningTime = 0;
	local nextOpeningTime = 0;
	local state = -1
	function setNextHourValues()
		if object.votOtherMod.active and object.votOtherMod.stopOpeningTime then 
		--{closed={active=-1, state=-1, title="", text=""}, opened={active=-1, state=-1, title="", text=""}, infoWhen={time=15, visible=false, text=""}, globalInfo=false};
			object.votNextHour.closed.active = 0; object.votNextHour.closed.state = -1;
			object.votNextHour.opened.active = 0; object.votNextHour.opened.state = -1;
			object.votNextHour.infoWhen.text = "";
		else
			if votIsOpening then
				object.votNextHour.opened.active = nextOpeningTime;
				object.votNextHour.opened.state = state;			
			else
				object.votNextHour.closed.active = nextOpeningTime;
				object.votNextHour.closed.state = state;
			end;
		end;
	
	end;
	function getVisible()
		if votIsOpening then
			nextClosedHour = object.votOpeningTime[activeOpeningTime].endTime;
			if nextClosedHour == 0 then nextClosedHour = 24;end;
			return nextClosedHour-1 == currentHour and 60-currentMin <= object.votNextHour.infoWhen.time;
		else
			nextOpenedHour = object.votOpeningTime[nextOpeningTime].startTime;
			if nextOpenedHour == 0 then nextOpenedHour = 24;end;			
			return nextOpenedHour-1 == currentHour and 60-currentMin <= object.votNextHour.infoWhen.time;
		end;
	end;	
	if object.votOtherMod.active and object.votOtherMod.stopOpeningTime then 
		votProductionInGameFrame:setInfoText(object, "");
		--object.votNextOpenedHour = -1; 
		--object.votNextClosedHour = -1; 
		object.votIsOpening = false;
		object.votActiveOpeningTime = activeOpeningTime;
		object.votNextActiveOpeningTime = nextOpeningTime;
		return false, activeOpeningTime, nextOpeningTime;
	end;
	for a=1, #object.votOpeningTime do
		if object.votOpeningTime[a].startTime ~= nil and object.votOpeningTime[a].endTime ~= nil then
			if currentHour >= object.votOpeningTime[a].startTime and currentHour < object.votOpeningTime[a].endTime then --16:45, 17-18
				activeOpeningTime = a;
				votIsOpening = true;
				if a == #object.votOpeningTime then nextOpeningTime = 1;else nextOpeningTime = a+1;end;
				break;
			end;			
			nextOpenedHour = object.votOpeningTime[a].startTime;
			if nextOpenedHour == 0 then nextOpenedHour = 24;end; 		
			if (currentHour+24)-nextOpenedHour < tempNextOpenedHour then tempNextOpenedHour = object.votOpeningTime[a].startTime;nextOpeningTime = a;end;			
		end;
	end;
	if nextOpeningTime == 0 then nextOpeningTime = 1;end;
	if object.votNextHour.infoWhen.time > 0 then
		if votIsOpening then
			--"! ".. g_i18n:getText("vot_ClosedNext").. " ".. string.format(g_i18n:getText("ui_pendingMissionTimeLeft"), 60-currentMin).. " !") --oder optional in minutem ! hm....
			object.votNextHour.infoWhen.title = g_i18n:getText("vot_ClosedNext");
			object.votNextHour.infoWhen.text = string.format(string.gsub(g_i18n:getText("vot_ClockTime"), "-", ""), "", tostring(object.votOpeningTime[activeOpeningTime].endTime));
			object.votNextHour.infoWhen.visible = getVisible();
			if object.votNextHour.infoWhen.visible then votProductionInGameFrame:setInfoText(object, " ! ".. g_i18n:getText("vot_ClosedNext").. "  (".. string.format(string.gsub(g_i18n:getText("vot_ClockTime"), "-", ""), "", tostring(object.votOpeningTime[activeOpeningTime].endTime)).. ") !");end;
		else
			object.votNextHour.infoWhen.title = g_i18n:getText("vot_OpenedNext");
			--print("---nextOpeningTime: ".. tostring(#object.votOpeningTime))
			object.votNextHour.infoWhen.text = string.format(string.gsub(g_i18n:getText("vot_ClockTime"), "-", ""), "", tostring(object.votOpeningTime[nextOpeningTime].startTime));
			object.votNextHour.infoWhen.visible = getVisible();
			if object.votNextHour.infoWhen.visible then votProductionInGameFrame:setInfoText(object, " - ".. g_i18n:getText("vot_OpenedNext").. "  (".. string.format(string.gsub(g_i18n:getText("vot_ClockTime"), "-", ""), "", tostring(object.votOpeningTime[nextOpeningTime].startTime)).. ")");end;
		end;
		if not object.votNextHour.infoWhen.visible then votProductionInGameFrame:setInfoText(object, "");end;		
	end;
	setNextHourValues();	
	object.votIsOpening = votIsOpening; --global	
	object.votActiveOpeningTime = activeOpeningTime; --global
	object.votNextActiveOpeningTime = nextOpeningTime; --global
	return votIsOpening, activeOpeningTime, nextOpeningTime; --optional
end;

function votSetGet:isRevampHourlysPresent(object, votXML, key, key1, key2) --Revamp Zeiten suchen/überprüfen und gegebenfalls unsere deaktivieren (Revamp Hourly hat also immmer Priorität wenn vorhanden und correct vom Modder hinterlegt wurde)
	local masterHours = votXML:hasProperty(key.. key1) and votXML:hasProperty(key.. key2) and votXML:hasProperty(key.. "#mode") and string.find(votXML:getString(key.. "#mode", ""), "hourly");
	if masterHours then return 1;end;	
	key = key.. ".production";	
	local status = 0;
	if object ~= nil and object.productions ~= nil and #object.productions > 0 then
		int = 0;
		while true do
			local groupNameTag = (key.. "(%d)"):format(int);
			if int > #object.productions then break;end;
			if groupNameTag ~= nil and votXML:hasProperty(groupNameTag.. key1) and votXML:hasProperty(groupNameTag.. key2) and votXML:hasProperty(groupNameTag.. "#mode") and string.find(votXML:getString(groupNameTag.. "#mode", ""), "hourly") then
				status = 2;break;			
			end;
			int = int+1;			
		end;		
	end;	
	return status;
end;

function votSetGet:setOpeningTimeValuesAtObject(object, votXML, masterKey, key1, key2, checkRevamp, setFrames, setBox, typ) --alle Werte fest in den Objekten hinterlegen
	if object == nil or votXML == nil then return false, "object or XML missing / typ: ".. tostring(typ);end;
	if object.votOpeningTime ~= nil then return false, "object OpeningTime already exists / typ: ".. tostring(typ);end;
	object.votTyp = typ;
	object.votOtherMod = {active=false, stopOpeningTime=false, title="", text="", info=""}; --other Mods support
	if object.votFrameText == nil then object.votFrameText = {isLoad=false, title="", openingTime="", info="Info"};end; --feste werte für frames, wurde eventuell schon vorher erstellt	
	object.votNextHour = {closed={active=-1, state=-1, title="", text=""}, opened={active=-1, state=-1, title="", text=""}, infoWhen={time=15, visible=false, title="", text="", callback=nil}, globalInfo=false};
	object.votRevamp = {hourlyMode=0,found=object.priorityPreset ~= nil}; --revamp support
	object.votActiveOpeningTime = 0;
	object.votNextActiveOpeningTime = 0;
	object.votShowInfo = true;
	if checkRevamp and object.votRevamp.found then object.votRevamp.hourlyMode = votSetGet:isRevampHourlysPresent(object, votXML, "placeable.productionPoint.productions", "#startHour", "#endHour");end;	--revamp support only productions, ! mode hourly vorhanden !
	--if not object.votRevamp.found and object.votRevamp.hourlyMode == 1 then key1 = "#startHour";key2 = "#endHour";object.votRevamp.hourlyMode = 0;end; --revamp support, Zeiten für Revamp vorhanden (nur wenn global gesetzt wurde)! Aber Revamp Mod nicht! Dann Zeiten von Revamp übernehmen
	if object.votRevamp.hourlyMode == 0 then					
		local isOkay, typ = votSetGet:formatOpeningTimeString(object, votXML, masterKey, key1, key2, typ);		
		if isOkay then
			object.votIsOpening = true;
			if setFrames then votProductionInGameFrame:setTitleAndTimeText(object);end;			
			if setBox then				
				local typNode = object.rootNode or object.nodeId or object.node;				
				if typNode ~= nil and typNode ~= 0 then					
					votSetGet:generateIngameOpeningTimeFrameBox(typ.. "_".. tostring(typNode));
					if VariableOpeningTime.ingameBoxFrames.hudBox[typ.. "_".. tostring(typNode)] ~= nil then VariableOpeningTime.ingameBoxFrames.hudBox[typ.. "_".. tostring(typNode)].object = object;end;
				end;
			end;			
			return true;
		else
			object.votOpeningTime = nil;
			return false, "formatString(keys) not correct or missing / typ: ".. tostring(typ);
		end;					
	else
		return false, "Revamp HourlyMode ".. tostring(object.votRevamp.hourlyMode).. " present / typ: ".. tostring(typ);
	end;
	return false, "other Error / typ: ".. tostring(typ);
end;

function votSetGet:formatOpeningTimeString(object, votXML, key, key1, key2, typ) --XML Werte verarbeiten	
	if object == nil or votXML == nil then return false, typ;end;		
	local hashStartTime = votXML:hasProperty(key.. key1);
	local hashEndTime = votXML:hasProperty(key.. key2);
	if not hashStartTime or not hashEndTime then return false, typ;end;
	local startTimeString = votSetGet:stringSplit(votXML:getString(key.. key1, "").. " ", " ", " ");
	local endTimeString = votSetGet:stringSplit(votXML:getString(key.. key2, "").. " ", " ", " ");	
	if #startTimeString <= 0 or #endTimeString <= 0 then return false, typ;end;	
	for t=1, VariableOpeningTime.maxStartEndTime do		 
		if startTimeString[t] ~= nil and startTimeString[t]:len() > 0 and endTimeString[t] ~= nil and endTimeString[t]:len() > 0 then
			if votSetGet:isOpeningTimeCorrect(tonumber(startTimeString[t]), tonumber(endTimeString[t])) then			
				votSetGet:addOpeningTime(object, startTimeString[t], endTimeString[t], "none");
			end;
		end;	
	end;
	local hashLoadingIfClosed = votXML:hasProperty(key.. "#loadingIfClosed");
	if hashLoadingIfClosed then object.votLoadingIfClosed= votXML:getBool(key.. "#loadingIfClosed", false);end;	
	local hashUnloadingIfClosed = votXML:hasProperty(key.. "#unloadingIfClosed");
	if hashUnloadingIfClosed then object.votUnloadingIfClosed= votXML:getBool(key.. "#unloadingIfClosed", false);end;	
	local hashShowInfo = votXML:hasProperty(key.. "#showInfo");
	if hashShowInfo then object.votShowInfo = votXML:getBool(key.. "#showInfo", true);end;
	local hashInfoWhen = votXML:hasProperty(key.. "#infoWhen");
	if hashInfoWhen then object.votNextHour.infoWhen.time = votXML:getInt(key.. "#infoWhen", 15);end;
	if object.votNextHour.infoWhen.time > 60 then object.votNextHour.infoWhen.time = 60;end;
	local hashGlobalInfo = votXML:hasProperty(key.. "#globalInfo");
	if hashGlobalInfo then object.votNextHour.globalInfo = votXML:getBool(key.. "#gobalInfo", false);end;
	return true, typ;	
end;

function votSetGet:isOpeningTimeCorrect(startTime, endTime) --XML Werte prüfen
	if type(startTime) ~= "number" or type(endTime) ~= "number" then return false;end;
	local startTimeOkay = false;local endTimeOkay = false;
	local checkStartTime = 0;local checkEndTime = 24;
	if startTime == endTime or (startTime == checkStartTime and endTime == checkEndTime) then return false;end;	
	if (startTime >= checkStartTime and startTime <= checkEndTime) or (startTime <= checkEndTime) then startTimeOkay = true;end;
	if (endTime <= checkEndTime and endTime >= checkStartTime) or (endTime >= checkStartTime) then endTimeOkay = true;end;
	return startTimeOkay and endTimeOkay;
end;

function votSetGet:addOpeningTime(object, startTime, endTime, special) --XML Werte in Objecte setzen
	if object.votOpeningTime == nil then object.votOpeningTime = {};end;	
	object.votOpeningTime[#object.votOpeningTime+1] = {startTime=tonumber(startTime),endTime=tonumber(endTime),special=special};
	if #object.votOpeningTime > 1 then table.sort(object.votOpeningTime, function(w1,w2)return w1.startTime<w2.startTime;end);end;
end;

function votSetGet:generateIngameOpeningTimeFrameBox(typ)
	if VariableOpeningTime:getServer() then return;end; 
	if g_currentMission.hud ~= nil and g_currentMission.hud.infoDisplay ~= nil then		
		if typ == nil and VariableOpeningTime.ingameBoxFrames.openingTime == nil then
			VariableOpeningTime.ingameBoxFrames.openingTime = g_currentMission.hud.infoDisplay:createBox(KeyValueInfoHUDBox);
			VariableOpeningTime.ingameBoxFrames.openingTime:setTitle("Variable Opening Time(Mod)");					
		elseif typ ~= nil and VariableOpeningTime.ingameBoxFrames.hudBox[typ] == nil then			
			VariableOpeningTime.ingameBoxFrames.hudBox[typ] = g_currentMission.hud.infoDisplay:createBox(KeyValueInfoHUDBox);
			VariableOpeningTime.ingameBoxFrames.hudBox[typ]:setTitle("Variable Opening Time(Mod)");
			VariableOpeningTime.ingameBoxFrames.hudBox[typ].visible = false;			
		end;
	end;
end;

function votSetGet:generateIngameOpeningTimeFrameBoxChange(object, typNode)
	if object ~= nil then
		if object.votTyp == "beehive" and votBeehive.viewOwnShowInfo then
			votSetGet:generateIngameOpeningTimeFrameBox(typNode);
		elseif object.votTyp == "sellingStation" and votSellingStation.viewOwnShowInfo then
			votSetGet:generateIngameOpeningTimeFrameBox(typNode);
		elseif object.votTyp == "buyingStation" and votBuyingStation.viewOwnShowInfo then
			votSetGet:generateIngameOpeningTimeFrameBox(typNode);
		elseif object.votTyp == "productionPoint" and votProduction.viewOwnShowInfo then
			votSetGet:generateIngameOpeningTimeFrameBox(typNode);	
		elseif (object.votTyp == "animatedObject" or object.votTyp == "animatedMapObject" or object.votTyp == "animatedFenceObject") and votAnimated.viewOwnShowInfo then
			votSetGet:generateIngameOpeningTimeFrameBox(typNode);
		end;
		if VariableOpeningTime.ingameBoxFrames.hudBox[typNode] ~= nil then VariableOpeningTime.ingameBoxFrames.hudBox[typNode].object = object;end;
	end;	
end;

function votSetGet:disabledHudBox()
	if VariableOpeningTime.ingameBoxFrames.hudBox ~= nil then
		for hud, box in pairs(VariableOpeningTime.ingameBoxFrames.hudBox) do
			if box ~= nil and box.visible then
				box.visible = false;				
			end;
		end; 
	end;
end;

function votSetGet:getClosedText(object)
	if object == nil then return false;end;
	local text = "";
	local objectName = object:getName() or "Unknown";
	local closedTxt = tostring(g_i18n:getText("vot_Closed", "closed"));
	if object.votTyp == "sellingStation" then
		local failedSellTxt = g_i18n:getText("shop_messageFailedToSellVehicle");		
		local sellStationTxt = g_i18n:getText("shopItem_sellStation");
		text = failedSellTxt.. "\n".. tostring(sellStationTxt).. " (".. tostring(objectName).. ") ";
	elseif object.votTyp == "productionPoint" then
		local productionTxt = g_i18n:getText("ui_productions_production", "Production");
		text = productionTxt.. " (".. tostring(objectName).. ") ";
	elseif object.votTyp == "buyingStation" then
		local failedBuyTxt = g_i18n:getText("ui_buy").. " "..  g_i18n:getText("ui_stations");
		text = failedBuyTxt.. " (".. tostring(objectName).. ") ";
	else
		text = tostring(objectName).. " ";
	end;
	return true, text.. closedTxt;
end;

function votSetGet:getDistance(object, nodeId, distance, onFoot, onVehicle)
	if object == nil and nodeId == nil then return false;end;
	local objectId = nodeId or object.rootNode or object.nodeId;
	local otherId = nil;				
	if g_currentMission.controlledVehicle ~= nil and onVehicle then
		otherId = g_currentMission.controlledVehicle.rootNode or g_currentMission.controlledVehicle.nodeId;
	elseif g_currentMission.player ~= nil and onFoot then
		otherId = g_currentMission.player.rootNode or g_currentMission.player.nodeId;
	else
		otherId = getCamera();
	end;
	if objectId ~= nil and otherId ~= nil then		
		return calcDistanceFrom(objectId, otherId) <= distance;		
	end;
	return false;
end;

function votSetGet:getVotObject(object, needTyp)	
	local isVotObject = object ~= nil and object.votOpeningTime ~= nil;
	if isVotObject then 
		if (needTyp and object.votTyp ~= nil) or not needTyp then
			return true, object;
		end;
		return false;		
	end;
	if not isVotObject then 
		isVotObject = object ~= nil and object.owningPlaceable ~= nil and object.owningPlaceable.spec_productionPoint ~= nil and object.owningPlaceable.spec_productionPoint.productionPoint ~= nil and object.owningPlaceable.spec_productionPoint.productionPoint.votOpeningTime ~= nil;
	end;
	if isVotObject then
		if (needTyp and object.owningPlaceable.spec_productionPoint.productionPoint.votTyp ~= nil) or not needTyp then
			return true, object.owningPlaceable.spec_productionPoint.productionPoint;
		end;
		return false;
	end;
	if not isVotObject then
		isVotObject = object ~= nil and object.spec_productionPoint ~= nil and object.spec_productionPoint.productionPoint ~= nil and object.spec_productionPoint.productionPoint.votOpeningTime ~= nil;
	end;
	if isVotObject then
		if (needTyp and object.spec_productionPoint.productionPoint.votTyp ~= nil) or not needTyp then
			return true, object.spec_productionPoint.productionPoint;
		end;
		return false;
	end;
	
	if not isVotObject then 
		isVotObject = object ~= nil and object.owningPlaceable ~= nil and object.owningPlaceable.spec_extendedProductionPoint ~= nil and object.owningPlaceable.spec_extendedProductionPoint.productionPoint ~= nil and object.owningPlaceable.spec_extendedProductionPoint.productionPoint.votOpeningTime ~= nil;
	end;
	if isVotObject then
		if (needTyp and object.owningPlaceable.spec_extendedProductionPoint.productionPoint.votTyp ~= nil) or not needTyp then
			return true, object.owningPlaceable.spec_extendedProductionPoint.productionPoint;
		end;
		return false;
	end;
	if not isVotObject then
		isVotObject = object ~= nil and object.spec_extendedProductionPoint ~= nil and object.spec_extendedProductionPoint.productionPoint ~= nil and object.spec_extendedProductionPoint.productionPoint.votOpeningTime ~= nil;
	end;
	if isVotObject then
		if (needTyp and object.spec_extendedProductionPoint.productionPoint.votTyp ~= nil) or not needTyp then
			return true, object.spec_extendedProductionPoint.productionPoint;
		end;
		return false;
	end;
	return false;
end;

function votSetGet:getCurrentTime()
	local hours = 0;
	local minutes = 0;
	function getIngameTime()
		local currentTime = g_currentMission.environment.dayTime / 3600000;
		hours = math.floor(currentTime);
		minutes = math.floor((currentTime - hours) * 60);
		minutes = string.format("%02.f", minutes);
		hours = string.format("%02.f", hours);
		--return string.format("%02d:%02d", timeHours, timeMinutes);	
	end;
	if g_currentMission.hl.version >= 0.75 then					
		hours, minutes = g_currentMission.hl.getMilliSecondsToHours(g_currentMission.environment.dayTime, false, false, false, true, true, false);								
	else
		getIngameTime();						
	end;
	return string.format(string.gsub(g_i18n:getText("vot_ClockTime"), "-", ":"), tostring(hours), tostring(minutes));
end;

function votSetGet:stringSplit(txtString,delimiter,formatting) --by _hl Script
	local result={};
	local from=1;
	if txtString==nil or delimiter==nil or type(txtString) ~= "string" or string.len(txtString) <= 1 then return result;end; --ab 0.71
	local delim_from,delim_to=string.find(txtString,delimiter,from,formatting);
	while delim_from do
		table.insert(result,string.sub(txtString,from,delim_from-1));
		from=delim_to+1;
		delim_from,delim_to=string.find(txtString,delimiter,from,formatting);
	end;
	table.insert(result,string.sub(txtString,from));
	return result;
end;